/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleAdsStaticUserAuthAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleAdsStaticUserAuthAllOf{}

// GoogleAdsStaticUserAuthAllOf struct for GoogleAdsStaticUserAuthAllOf
type GoogleAdsStaticUserAuthAllOf struct {
	DeveloperToken   *string `json:"developerToken,omitempty"`
	ClientCustomerId *string `json:"clientCustomerId,omitempty"`
	ClientId         *string `json:"clientId,omitempty"`
	ClientSecret     *string `json:"clientSecret,omitempty"`
	RedirectUri      *string `json:"redirectUri,omitempty"`
}

// NewGoogleAdsStaticUserAuthAllOf instantiates a new GoogleAdsStaticUserAuthAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleAdsStaticUserAuthAllOf() *GoogleAdsStaticUserAuthAllOf {
	this := GoogleAdsStaticUserAuthAllOf{}
	return &this
}

// NewGoogleAdsStaticUserAuthAllOfWithDefaults instantiates a new GoogleAdsStaticUserAuthAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleAdsStaticUserAuthAllOfWithDefaults() *GoogleAdsStaticUserAuthAllOf {
	this := GoogleAdsStaticUserAuthAllOf{}
	return &this
}

// GetDeveloperToken returns the DeveloperToken field value if set, zero value otherwise.
func (o *GoogleAdsStaticUserAuthAllOf) GetDeveloperToken() string {
	if o == nil || IsNil(o.DeveloperToken) {
		var ret string
		return ret
	}
	return *o.DeveloperToken
}

// GetDeveloperTokenOk returns a tuple with the DeveloperToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsStaticUserAuthAllOf) GetDeveloperTokenOk() (*string, bool) {
	if o == nil || IsNil(o.DeveloperToken) {
		return nil, false
	}
	return o.DeveloperToken, true
}

// HasDeveloperToken returns a boolean if a field has been set.
func (o *GoogleAdsStaticUserAuthAllOf) HasDeveloperToken() bool {
	if o != nil && !IsNil(o.DeveloperToken) {
		return true
	}

	return false
}

// SetDeveloperToken gets a reference to the given string and assigns it to the DeveloperToken field.
func (o *GoogleAdsStaticUserAuthAllOf) SetDeveloperToken(v string) {
	o.DeveloperToken = &v
}

// GetClientCustomerId returns the ClientCustomerId field value if set, zero value otherwise.
func (o *GoogleAdsStaticUserAuthAllOf) GetClientCustomerId() string {
	if o == nil || IsNil(o.ClientCustomerId) {
		var ret string
		return ret
	}
	return *o.ClientCustomerId
}

// GetClientCustomerIdOk returns a tuple with the ClientCustomerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsStaticUserAuthAllOf) GetClientCustomerIdOk() (*string, bool) {
	if o == nil || IsNil(o.ClientCustomerId) {
		return nil, false
	}
	return o.ClientCustomerId, true
}

// HasClientCustomerId returns a boolean if a field has been set.
func (o *GoogleAdsStaticUserAuthAllOf) HasClientCustomerId() bool {
	if o != nil && !IsNil(o.ClientCustomerId) {
		return true
	}

	return false
}

// SetClientCustomerId gets a reference to the given string and assigns it to the ClientCustomerId field.
func (o *GoogleAdsStaticUserAuthAllOf) SetClientCustomerId(v string) {
	o.ClientCustomerId = &v
}

// GetClientId returns the ClientId field value if set, zero value otherwise.
func (o *GoogleAdsStaticUserAuthAllOf) GetClientId() string {
	if o == nil || IsNil(o.ClientId) {
		var ret string
		return ret
	}
	return *o.ClientId
}

// GetClientIdOk returns a tuple with the ClientId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsStaticUserAuthAllOf) GetClientIdOk() (*string, bool) {
	if o == nil || IsNil(o.ClientId) {
		return nil, false
	}
	return o.ClientId, true
}

// HasClientId returns a boolean if a field has been set.
func (o *GoogleAdsStaticUserAuthAllOf) HasClientId() bool {
	if o != nil && !IsNil(o.ClientId) {
		return true
	}

	return false
}

// SetClientId gets a reference to the given string and assigns it to the ClientId field.
func (o *GoogleAdsStaticUserAuthAllOf) SetClientId(v string) {
	o.ClientId = &v
}

// GetClientSecret returns the ClientSecret field value if set, zero value otherwise.
func (o *GoogleAdsStaticUserAuthAllOf) GetClientSecret() string {
	if o == nil || IsNil(o.ClientSecret) {
		var ret string
		return ret
	}
	return *o.ClientSecret
}

// GetClientSecretOk returns a tuple with the ClientSecret field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsStaticUserAuthAllOf) GetClientSecretOk() (*string, bool) {
	if o == nil || IsNil(o.ClientSecret) {
		return nil, false
	}
	return o.ClientSecret, true
}

// HasClientSecret returns a boolean if a field has been set.
func (o *GoogleAdsStaticUserAuthAllOf) HasClientSecret() bool {
	if o != nil && !IsNil(o.ClientSecret) {
		return true
	}

	return false
}

// SetClientSecret gets a reference to the given string and assigns it to the ClientSecret field.
func (o *GoogleAdsStaticUserAuthAllOf) SetClientSecret(v string) {
	o.ClientSecret = &v
}

// GetRedirectUri returns the RedirectUri field value if set, zero value otherwise.
func (o *GoogleAdsStaticUserAuthAllOf) GetRedirectUri() string {
	if o == nil || IsNil(o.RedirectUri) {
		var ret string
		return ret
	}
	return *o.RedirectUri
}

// GetRedirectUriOk returns a tuple with the RedirectUri field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsStaticUserAuthAllOf) GetRedirectUriOk() (*string, bool) {
	if o == nil || IsNil(o.RedirectUri) {
		return nil, false
	}
	return o.RedirectUri, true
}

// HasRedirectUri returns a boolean if a field has been set.
func (o *GoogleAdsStaticUserAuthAllOf) HasRedirectUri() bool {
	if o != nil && !IsNil(o.RedirectUri) {
		return true
	}

	return false
}

// SetRedirectUri gets a reference to the given string and assigns it to the RedirectUri field.
func (o *GoogleAdsStaticUserAuthAllOf) SetRedirectUri(v string) {
	o.RedirectUri = &v
}

func (o GoogleAdsStaticUserAuthAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleAdsStaticUserAuthAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.DeveloperToken) {
		toSerialize["developerToken"] = o.DeveloperToken
	}
	if !IsNil(o.ClientCustomerId) {
		toSerialize["clientCustomerId"] = o.ClientCustomerId
	}
	if !IsNil(o.ClientId) {
		toSerialize["clientId"] = o.ClientId
	}
	if !IsNil(o.ClientSecret) {
		toSerialize["clientSecret"] = o.ClientSecret
	}
	if !IsNil(o.RedirectUri) {
		toSerialize["redirectUri"] = o.RedirectUri
	}
	return toSerialize, nil
}

type NullableGoogleAdsStaticUserAuthAllOf struct {
	value *GoogleAdsStaticUserAuthAllOf
	isSet bool
}

func (v NullableGoogleAdsStaticUserAuthAllOf) Get() *GoogleAdsStaticUserAuthAllOf {
	return v.value
}

func (v *NullableGoogleAdsStaticUserAuthAllOf) Set(val *GoogleAdsStaticUserAuthAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleAdsStaticUserAuthAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleAdsStaticUserAuthAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleAdsStaticUserAuthAllOf(val *GoogleAdsStaticUserAuthAllOf) *NullableGoogleAdsStaticUserAuthAllOf {
	return &NullableGoogleAdsStaticUserAuthAllOf{value: val, isSet: true}
}

func (v NullableGoogleAdsStaticUserAuthAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleAdsStaticUserAuthAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
